#version 430 core

in vec2 TexCoord0;
flat in float TTL0;
layout (location = 0) out vec4 FragColor;
layout (location = 1) out vec2 MotionVector;

vec3 pow3(vec3 v, float p) {    return pow(abs(v), vec3(p));    }

vec3 glowSphere(vec3 color, vec2 p, float radius, float glow) {
  // Inspired by https://www.shadertoy.com/view/4lfXRf
  float term = 1./length(p)/5.;
  return pow3(color * term * 0.7, glow) * radius;
}

void main() {
  vec3 baseColor = vec3(0.66, 0.67, 0.71) * clamp(TTL0, 0.0, 1.0);
  vec3 color = glowSphere(baseColor, TexCoord0 * 2 - 1, 3, 3.25);
  float lum = dot(color, vec3(0.299, 0.587, 0.114));
  FragColor = vec4(color, 1.0); // use luminance as alpha
  MotionVector = vec2(0,0);
  }