#version 430

in vec2 TexCoords;

uniform sampler2D gColorTexture;
uniform sampler2D gMotionTexture;
uniform float   fps;


out vec4 oResult;

   
   
   void main(void) {
		vec2 texelSize = 1.0 / vec2(textureSize(gColorTexture, 0));
		vec2 screenTexCoords = gl_FragCoord.xy * texelSize;
		vec2 velocity = texture(gMotionTexture, screenTexCoords).xy;
		float uVelocityScale=fps/12;
		velocity *= uVelocityScale;

		float speed = length(velocity/texelSize);
		float  nSamples = clamp(int(speed), 1, 100);
   
		oResult = texture(gColorTexture, screenTexCoords);
		for (int i = 1; i < nSamples; ++i) {
			vec2 offset = velocity * (float(i) / float(nSamples - 1) - 0.5);
			vec4 blsample = texture(gColorTexture, screenTexCoords + offset);
			
			if(length(blsample) < 3.98){
			oResult += blsample;
			}else{
				oResult += texture(gColorTexture, screenTexCoords + 15*offset);
			}
		}
		
		
   
		 oResult /= float(nSamples);
   
   }
